import numpy as np
import matplotlib.pyplot as plt
from scipy import stats

def float_list(l):
    L = []
    for i in l:
        L.append(float(i))
    return(L)

def print_data(fichier):
    fichier = open(fichier, "r")
    A = fichier.read()
    L = [[],[],[],[],[]]
    a = ""
    l = 0
    for i in A:
        if (i == " ") :
            if l == 0: 
                L[0].append(a)
                l +=1
            elif l == 1:
                L[1].append(a)
                #print(a)
                l += 1
            elif l == 2:
                L[2].append(a)
                l += 1
            elif l == 3:
                L[3].append(a)
                l += 1
            else:
                L[4].append(a)
                l = 0
            a = ""
        elif (i == "\n") :
            a = ""
        else:
            a += i
    fichier.close()

    for i in range(5):
        L[i] = float_list(L[i])
    print_graph(L)

def print_graph(L):
    a = np.array([L[0][i],L[1][i]] for i in range(len(L[0])))
    fig = plt.figure(1)
    plt.clf()
    
    lr1 = stats.linregress(L[0],L[1]) # return tuple (pente,ordonnee a l'origine, coef de correlation, p-value, erreur standard de l'estimation)
    plt.plot(L[0],L[1], "r", label = "BMP_ref")
    plt.plot(L[0],[lr1.slope*i + lr1.intercept for i in L[0]], "r--", label = "BMP_ref regression line, \nerror = "+str(lr1.stderr)+",\ncorrelation coefficient = "+str(lr1.rvalue))
    
    lr2 = stats.linregress(L[0],L[2])
    plt.plot(L[0],L[2], "b", label = "BMP_impr")
    plt.plot(L[0],[lr2.slope*i + lr2.intercept for i in L[0]], "b--", label = "BMP_impr regression line, \nerror = "+str(lr2.stderr)+",\ncorrelation coefficient = "+str(lr2.rvalue))

    lr3 = stats.linregress(L[0],L[3])
    plt.plot(L[0],L[3], "g", label = "BMP_ref")
    plt.plot(L[0],[lr3.slope*i + lr3.intercept for i in L[0]], "g--", label = "BMP_ref regression line, \nerror = "+str(lr3.stderr)+",\ncorrelation coefficient = "+str(lr3.rvalue))

    lr4 = stats.linregress(L[0],L[4])
    plt.plot(L[0],L[4], "m", label = "BMP_impr")
    plt.plot(L[0],[lr4.slope*i + lr4.intercept for i in L[0]], "m--", label = "BMP_impr regression line, \nerror = "+str(lr4.stderr)+",\ncorrelation coefficient = "+str(lr4.rvalue))
    
    plt.legend()
    plt.xlabel("length in motor step")
    plt.ylabel("tension in V")
    plt.show()

    
"""    
    ax2 = fig.add_axes((0.1,0.1,0.8,0.0))
    ax2.yaxis.set_visible(False) # hide the yaxis
    ax2.set_xticklabels(10*L[0])
    ax2.set_xlabel("lenght in mm")
    plt.show()
"""


print_data("data/position_vs_tension_ch1-3_bpm_ref_ch2-4_bpm_impr_20180611_160153_0.txt")
print_data("data/position_vs_tension_ch1-3_bpm_ref_ch2-4_bpm_impr_20180611_163036_0.txt")
